//------------------------------------------------------------------------------
// <auto-generated />
//
// This file was automatically generated by SWIG (http://www.swig.org).
// Version 3.0.12
//
// Do not make changes to this file unless you know what you are doing--modify
// the SWIG interface file instead.
//------------------------------------------------------------------------------


public class Object : global::System.IDisposable {
  private global::System.Runtime.InteropServices.HandleRef swigCPtr;
  protected bool swigCMemOwn;

  internal Object(global::System.IntPtr cPtr, bool cMemoryOwn) {
    swigCMemOwn = cMemoryOwn;
    swigCPtr = new global::System.Runtime.InteropServices.HandleRef(this, cPtr);
  }

  internal static global::System.Runtime.InteropServices.HandleRef getCPtr(Object obj) {
    return (obj == null) ? new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero) : obj.swigCPtr;
  }

  ~Object() {
    Dispose();
  }

  public virtual void Dispose() {
    lock(this) {
      if (swigCPtr.Handle != global::System.IntPtr.Zero) {
        if (swigCMemOwn) {
          swigCMemOwn = false;
          cssimplewrapPINVOKE.delete_Object(swigCPtr);
        }
        swigCPtr = new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero);
      }
      global::System.GC.SuppressFinalize(this);
    }
  }

  public Object() : this(cssimplewrapPINVOKE.new_Object__SWIG_0(), true) {
  }

  public Object(string name) : this(cssimplewrapPINVOKE.new_Object__SWIG_1(name), true) {
    if (cssimplewrapPINVOKE.SWIGPendingException.Pending) throw cssimplewrapPINVOKE.SWIGPendingException.Retrieve();
  }

  public void set_name(string name) {
    cssimplewrapPINVOKE.Object_set_name(swigCPtr, name);
    if (cssimplewrapPINVOKE.SWIGPendingException.Pending) throw cssimplewrapPINVOKE.SWIGPendingException.Retrieve();
  }

  public string get_name() {
    string ret = cssimplewrapPINVOKE.Object_get_name(swigCPtr);
    return ret;
  }

  public int set_data(SWIGTYPE_p_unsigned_char data, uint size) {
    int ret = cssimplewrapPINVOKE.Object_set_data(swigCPtr, SWIGTYPE_p_unsigned_char.getCPtr(data), size);
    return ret;
  }

  public int get_data(SWIGTYPE_p_unsigned_char data, SWIGTYPE_p_unsigned_int size) {
    int ret = cssimplewrapPINVOKE.Object_get_data__SWIG_0(swigCPtr, SWIGTYPE_p_unsigned_char.getCPtr(data), SWIGTYPE_p_unsigned_int.getCPtr(size));
    if (cssimplewrapPINVOKE.SWIGPendingException.Pending) throw cssimplewrapPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  public SWIGTYPE_p_unsigned_char get_data(SWIGTYPE_p_unsigned_int size) {
    global::System.IntPtr cPtr = cssimplewrapPINVOKE.Object_get_data__SWIG_1(swigCPtr, SWIGTYPE_p_unsigned_int.getCPtr(size));
    SWIGTYPE_p_unsigned_char ret = (cPtr == global::System.IntPtr.Zero) ? null : new SWIGTYPE_p_unsigned_char(cPtr, false);
    if (cssimplewrapPINVOKE.SWIGPendingException.Pending) throw cssimplewrapPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

}
